#ifndef CINFOTIPHANDLER_H
#define CINFOTIPHANDLER_H

class CInfoTipHandler : public IQueryInfo, public IPersistFile
{
protected:
    IUnknown* GetUnknown() { return(static_cast<IQueryInfo*>(this)); }

public:
    //IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    //IQueryInfo
    IFACEMETHOD(GetInfoFlags)(DWORD* pdwFlags);
    IFACEMETHOD(GetInfoTip)(DWORD dwFlags, LPWSTR* ppwszTip);

    //IPersistfile
    IFACEMETHOD(GetClassID)(CLSID* pClassID);
    IFACEMETHOD(IsDirty)();
    IFACEMETHOD(Load)(LPCOLESTR pszFileName, DWORD dwMode);
    IFACEMETHOD(Save)(LPCOLESTR pszFileName, BOOL fRemember);
    IFACEMETHOD(SaveCompleted)(LPCOLESTR pszFileName);
    IFACEMETHOD(GetCurFile)(LPOLESTR* ppszFileName);

    explicit CInfoTipHandler(HRESULT* phr);
    virtual ~CInfoTipHandler();

private:
    static HRESULT GetTipHeader(LPWSTR* ppwszHdr, UINT64 dwNumImages);
    static HRESULT AppendImageInfo(__inout LPWSTR* ppwszTip, ...);

private:
    BSTR            m_bstrFileName;
    volatile ULONG  m_lRefCount;
#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif
};

#endif
