#include "precomp.h"

#define ENTRY_FILENAME  MAKEINTRESOURCE(1)

static const LPCTSTR RegEntryTable[][3] =
{
    { TEXT("CLSID\\{F1296BDF-D17E-4897-A69A-5E71DA1E88B1}"),                    nullptr,                TEXT("ToolTip-Handler for .ico Files")          },
    { TEXT("CLSID\\{F1296BDF-D17E-4897-A69A-5E71DA1E88B1}\\InprocServer32"),    nullptr,                ENTRY_FILENAME                                  },
    { TEXT("CLSID\\{F1296BDF-D17E-4897-A69A-5E71DA1E88B1}\\InprocServer32"),    TEXT("ThreadingModel"), TEXT("Both")                                    },
    { TEXT(".ico\\ShellEx\\{00021500-0000-0000-C000-000000000046}"),            nullptr,                TEXT("{F1296BDF-D17E-4897-A69A-5E71DA1E88B1}")  },
    { TEXT("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Shell Extensions\\Approved"), TEXT("{F1296BDF-D17E-4897-A69A-5E71DA1E88B1}"), TEXT("ToolTip-Handler for .ico Files") },
    { nullptr, nullptr, nullptr }
};

STDAPI DllUnregisterServer(VOID)
{
    HRESULT hr = S_OK;
    HKEY    hKey;
    INT     x;

    for(x = 0; RegEntryTable[x][0]; x++)
        ;

    while(--x >= 0)
    {
        if(RegEntryTable[x][1])
        {
            if(ERROR_SUCCESS != RegCreateKeyEx(HKEY_CLASSES_ROOT, RegEntryTable[x][0], 0, nullptr, REG_OPTION_NON_VOLATILE, KEY_WRITE, nullptr, &hKey, nullptr))
            {
                hr = S_FALSE;
                continue;
            }

            if(ERROR_SUCCESS != RegDeleteValue(hKey, RegEntryTable[x][1]))
                hr = S_FALSE;

            RegCloseKey(hKey);
        }
        else
        {
            if(ERROR_SUCCESS != RegDeleteKey(HKEY_CLASSES_ROOT, RegEntryTable[x][0]))
                hr = S_FALSE;
        }
    }

    return(hr);
}

STDAPI DllRegisterServer(VOID)
{
    UINT x = 0;

    while(RegEntryTable[x][0])
    {
        LONG lError;
        HKEY hKey;

        if(ERROR_SUCCESS == (lError = RegCreateKeyEx(HKEY_CLASSES_ROOT, RegEntryTable[x][0], 0, nullptr, REG_OPTION_NON_VOLATILE, KEY_WRITE, nullptr, &hKey, nullptr)))
        {
            if(ENTRY_FILENAME == RegEntryTable[x][2])
            {
                TCHAR szFileName[MAX_PATH * 2];
                GetModuleFileName(g_hInst, szFileName, _countof(szFileName));
                lError = RegSetValueEx(hKey, RegEntryTable[x][1], 0, REG_SZ, (BYTE*)szFileName, static_cast<DWORD>(_tcslen(szFileName) + 1) * sizeof(TCHAR));
            }
            else if(RegEntryTable[x][2])
            {
                lError = RegSetValueEx(hKey, RegEntryTable[x][1], 0, REG_SZ, (BYTE*)RegEntryTable[x][2], static_cast<DWORD>(_tcslen(RegEntryTable[x][2]) + 1) * sizeof(TCHAR));
            }
            RegCloseKey(hKey);
        }

        if(lError != ERROR_SUCCESS)
        {
            DllUnregisterServer();
            return(SELFREG_E_CLASS);
        }

        ++x;
    }

    return(S_OK);
}
